Index: src/org/jboss/tools/deltacloud/integration/wizard/RSEandASWizardPage.java
===================================================================
--- src/org/jboss/tools/deltacloud/integration/wizard/RSEandASWizardPage.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/integration/wizard/RSEandASWizardPage.java	(working copy)
@@ -11,14 +11,17 @@
 package org.jboss.tools.deltacloud.integration.wizard;
 
 import java.util.ArrayList;
+import java.util.List;
 
 import org.eclipse.core.runtime.preferences.IEclipsePreferences;
 import org.eclipse.core.runtime.preferences.InstanceScope;
+import org.eclipse.jface.fieldassist.ControlDecoration;
 import org.eclipse.jface.wizard.WizardPage;
 import org.eclipse.rse.core.model.IHost;
 import org.eclipse.swt.SWT;
 import org.eclipse.swt.events.ModifyEvent;
 import org.eclipse.swt.events.ModifyListener;
+import org.eclipse.swt.events.SelectionAdapter;
 import org.eclipse.swt.events.SelectionEvent;
 import org.eclipse.swt.events.SelectionListener;
 import org.eclipse.swt.layout.FormLayout;
@@ -36,28 +39,49 @@
 import org.jboss.tools.common.jobs.ChainedJob;
 import org.jboss.tools.deltacloud.core.DeltaCloudInstance;
 import org.jboss.tools.deltacloud.integration.DeltaCloudIntegrationPlugin;
+import org.jboss.tools.deltacloud.ui.preferences.StringPreferenceValue;
 import org.jboss.tools.deltacloud.ui.wizard.INewInstanceWizardPage;
+import org.jboss.tools.internal.deltacloud.ui.utils.LayoutUtils;
 import org.jboss.tools.internal.deltacloud.ui.utils.UIUtils;
 import org.osgi.service.prefs.BackingStoreException;
 
 /**
  * @author Rob Stryker
+ * @author André Dietisheim
  */
 public class RSEandASWizardPage extends WizardPage implements INewInstanceWizardPage {
-	private static final boolean DEFALUT_CREATE_RSE = true;
-	private static final boolean DETAULT_CREATE_SERVERADAPTER = false;
-	
+	private static final String SERVER_DETAILS_PROPOSAL_KEY = "server_details";
+	private static final String SERVER_HOME_PROPOSAL_KEY = "server_home";
+	private static final String SERVER_CONFIG_PROPOSAL_KEY = "server_config";
+	private static final String SERVER_DEPLOY_PROPOSAL_KEY = "server_deploy";
+
+	private static final String SELECTED_AUTO_LOCAL_RUNTIME_KEY = "autoruntime_selected";
+	private static final String SELECTED_MANUAL_LOCAL_RUNTIME_KEY = "manualruntime_selected";
+
+	private static final String SELECT_RUNTIME_ERROR = "Please select a local runtime. The created server will be of the same version as the local runtime.";
+	private static final String DEPLOY_FOLDER_NOT_EMPTY = "The deploy folder must not be empty";
+	private final static String REMOTE_DETAILS_LOC_ERROR = "You must fill in a path to fetch the server configuration from";
+	private static final String SERVER_CONFIG_ERROR = "You must select a server configuration";
+	private static final String SERVER_HOME_ERROR = "You must set a server home directory";
+
 	private final static String CREATE_RSE_PREF_KEY = "org.jboss.tools.deltacloud.integration.wizard.RSEandASWizard.CREATE_RSE_PREF_KEY";
 	private final static String CREATE_SERVER_PREF_KEY = "org.jboss.tools.deltacloud.integration.wizard.RSEandASWizard.CREATE_SERVER_PREF_KEY";
 
+	private static final boolean DEFALUT_CREATE_RSE = true;
+	private static final boolean DETAULT_CREATE_SERVERADAPTER = false;
+
 	private Button createRSE, createServer;
 	private Group serverDetailsGroup;
-	private Button autoScanCheck, hardCodeServerDetails, deployOnlyRadio, 
+	private Button autoScanCheck, hardCodeServerDetails, deployOnlyRadio,
 					addLocalRuntimeButton, autoAddLocalRuntimeButton;
+	private ControlDecoration deployFolderDeco, autoLocalRuntimeDeco, serverHomeDeco, remoteDetailsLocDeco,
+			localRuntimeDeco, serverConfigDeco;
 	private Text remoteDetailsLoc, serverHomeText, serverConfigText, deployFolderText;
 	private Label serverHome, serverConfig, localRuntimeLabel, autoLocalRuntimeLabel, deployFolder;
-	private Combo autoLocalRuntimeCombo,localRuntimeCombo;
-
+	private Combo autoLocalRuntimeCombo, localRuntimeCombo;
+	private StringPreferenceValue selectedAutoRuntimePref = new StringPreferenceValue(SELECTED_AUTO_LOCAL_RUNTIME_KEY, DeltaCloudIntegrationPlugin.PLUGIN_ID);
+	private StringPreferenceValue selectedManualRuntimePref = new StringPreferenceValue(SELECTED_MANUAL_LOCAL_RUNTIME_KEY, DeltaCloudIntegrationPlugin.PLUGIN_ID);
+	
 	private IHost initialHost;
 	private ArrayList<IRuntime> localRuntimes = new ArrayList<IRuntime>();
 
@@ -66,7 +90,7 @@
 		setTitle("Create RSE Connection and Server");
 		setDescription("Here you can choose to create a matching RSE connection and a Server adapter");
 	}
-	
+
 	public RSEandASWizardPage(IHost host) {
 		this();
 		this.initialHost = host;
@@ -77,93 +101,102 @@
 		c2.setLayout(new FormLayout());
 		createRSE = new Button(c2, SWT.CHECK);
 		createRSE.setText("Create RSE Connection");
-		createRSE.setLayoutData(UIUtils.createFormData(0, 5, null, 0, 0, 5, 100, -5));
+		createRSE.setLayoutData(LayoutUtils.createFormData(0, 5, null, 0, 0, 5, 100, -5));
 		createServer = new Button(c2, SWT.CHECK);
 		createServer.setText("Create Server Adapter");
-		createServer.setLayoutData(UIUtils.createFormData(createRSE, 5, null, 0, 0, 5, 100, -5));
+		createServer.setLayoutData(LayoutUtils.createFormData(createRSE, 5, null, 0, 0, 5, 100, -5));
 
 		Group g = new Group(c2, SWT.SHADOW_IN);
 		serverDetailsGroup = g;
 		g.setLayout(new FormLayout());
-		g.setLayoutData(UIUtils.createFormData(createServer,5,null,0,0,5,100,-5));
+		g.setLayoutData(LayoutUtils.createFormData(createServer, 5, null, 0, 0, 5, 100, -5));
 		g.setText("Server Details");
-		
+
 		final int INDENTATION = 40;
-		
+
 		autoScanCheck = new Button(g, SWT.RADIO);
 		autoScanCheck.setText("Determine server details from this remote file:");
-		autoScanCheck.setLayoutData(UIUtils.createFormData(0,5,null,0,0,5,null,0));
+		autoScanCheck.setLayoutData(LayoutUtils.createFormData(0, 5, null, 0, 0, 5, null, 0));
 		autoScanCheck.setSelection(true);
-		
+
 		remoteDetailsLoc = new Text(g, SWT.BORDER);
-		remoteDetailsLoc.setLayoutData(UIUtils.createFormData(autoScanCheck,5,null,0,0,INDENTATION,100,-5));
+		remoteDetailsLoc.setLayoutData(LayoutUtils.createFormData(autoScanCheck, 5, null, 0, 0, INDENTATION, 100, -5));
 		remoteDetailsLoc.setText("./.jboss");
-		
+		this.remoteDetailsLocDeco = UIUtils.createErrorDecoration(REMOTE_DETAILS_LOC_ERROR, remoteDetailsLoc);
+		UIUtils.createPreferencesProposalAdapter(remoteDetailsLoc, SERVER_DETAILS_PROPOSAL_KEY);
+
 		autoLocalRuntimeLabel = new Label(g, SWT.NONE);
 		autoLocalRuntimeLabel.setText("Local Runtime: ");
-		autoLocalRuntimeLabel.setLayoutData(UIUtils.createFormData(remoteDetailsLoc, 7, null, 0, 0, INDENTATION, null, 0 ));
-		
+		autoLocalRuntimeLabel.setLayoutData(
+				LayoutUtils.createFormData(remoteDetailsLoc, 7, null, 0, 0, INDENTATION, null,0));
+
 		autoAddLocalRuntimeButton = new Button(g, SWT.DEFAULT);
 		autoAddLocalRuntimeButton.setText("Configure Runtimes...");
-		autoAddLocalRuntimeButton.setLayoutData(UIUtils.createFormData(remoteDetailsLoc, 7, null, 0, null, 0, 100, -5));
-		autoAddLocalRuntimeButton.addSelectionListener(new SelectionListener() {
+		autoAddLocalRuntimeButton.setLayoutData(LayoutUtils.createFormData(remoteDetailsLoc, 7, null, 0, null, 0, 100, -5));
+		autoAddLocalRuntimeButton.addSelectionListener(new SelectionAdapter() {
 			public void widgetSelected(SelectionEvent e) {
 				configureRuntimesPressed();
 			}
-			public void widgetDefaultSelected(SelectionEvent e) {
-			}
 		});
 		autoLocalRuntimeCombo = new Combo(g, SWT.READ_ONLY);
-		autoLocalRuntimeCombo.setLayoutData(UIUtils.createFormData(remoteDetailsLoc, 5, null, 0, autoLocalRuntimeLabel, 5, autoAddLocalRuntimeButton, -5));
-		
-		
+		autoLocalRuntimeCombo.setLayoutData(LayoutUtils.createFormData(remoteDetailsLoc, 5, null, 0, autoLocalRuntimeLabel,
+				10, autoAddLocalRuntimeButton, -5));
+		this.autoLocalRuntimeDeco = UIUtils.createErrorDecoration(SELECT_RUNTIME_ERROR, autoLocalRuntimeCombo);
+
 		hardCodeServerDetails = new Button(g, SWT.RADIO);
 		hardCodeServerDetails.setText("Set remote server details manually");
-		hardCodeServerDetails.setLayoutData(UIUtils.createFormData(autoLocalRuntimeCombo,5,null,0,0,5,null,0));
+		hardCodeServerDetails.setLayoutData(LayoutUtils.createFormData(autoLocalRuntimeCombo, 5, null, 0, 0, 10, null, 0));
 
 		serverHome = new Label(g, SWT.NONE);
 		serverHome.setText("JBoss Server Home: ");
-		serverHome.setLayoutData(UIUtils.createFormData(hardCodeServerDetails, 7, null, 0, 0, INDENTATION, null, 0 ));
+		serverHome.setLayoutData(LayoutUtils.createFormData(hardCodeServerDetails, 7, null, 0, 0, INDENTATION, null, 0));
 		serverHomeText = new Text(g, SWT.BORDER);
-		serverHomeText.setLayoutData(UIUtils.createFormData(hardCodeServerDetails, 5, null, 0, serverHome, 5, 100, -5));
+		serverHomeText.setLayoutData(LayoutUtils.createFormData(hardCodeServerDetails, 5, null, 0, serverHome, 10, 100, -5));
 		serverHomeText.setText("/etc/jboss/jboss-as");
+		this.serverHomeDeco = UIUtils.createErrorDecoration(SERVER_HOME_ERROR, serverHomeText);
+		UIUtils.createPreferencesProposalAdapter(serverHomeText, SERVER_HOME_PROPOSAL_KEY);
 
 		serverConfig = new Label(g, SWT.NONE);
 		serverConfig.setText("Configuration: ");
-		serverConfig.setLayoutData(UIUtils.createFormData(serverHomeText, 7, null, 0, 0, INDENTATION, null, 0 ));
+		serverConfig.setLayoutData(LayoutUtils.createFormData(serverHomeText, 7, null, 0, 0, INDENTATION, null, 0));
 		serverConfigText = new Text(g, SWT.BORDER);
-		serverConfigText.setLayoutData(UIUtils.createFormData(serverHomeText, 5, null, 0, serverHome, 5, 100, -5));
+		serverConfigText.setLayoutData(LayoutUtils.createFormData(serverHomeText, 5, null, 0, serverHome, 10, 100, -5));
 		serverConfigText.setText("default");
-		
+		this.serverConfigDeco = UIUtils.createErrorDecoration(SERVER_CONFIG_ERROR, serverConfigText);
+		UIUtils.createPreferencesProposalAdapter(serverConfigText, SERVER_CONFIG_PROPOSAL_KEY);
+
 		localRuntimeLabel = new Label(g, SWT.NONE);
 		localRuntimeLabel.setText("Local Runtime: ");
-		localRuntimeLabel.setLayoutData(UIUtils.createFormData(serverConfigText, 7, null, 0, 0, INDENTATION, null, 0 ));
-		
+		localRuntimeLabel.setLayoutData(LayoutUtils.createFormData(serverConfigText, 7, null, 0, 0, INDENTATION, null, 0));
+
 		addLocalRuntimeButton = new Button(g, SWT.DEFAULT);
 		addLocalRuntimeButton.setText("Configure Runtimes...");
-		addLocalRuntimeButton.setLayoutData(UIUtils.createFormData(serverConfigText, 7, null, 0, null, 0, 100, -5));
-		addLocalRuntimeButton.addSelectionListener(new SelectionListener() {
+		addLocalRuntimeButton.setLayoutData(LayoutUtils.createFormData(serverConfigText, 7, null, 0, null, 0, 100, -5));
+		addLocalRuntimeButton.addSelectionListener(new SelectionAdapter() {
 			public void widgetSelected(SelectionEvent e) {
 				configureRuntimesPressed();
 			}
-			public void widgetDefaultSelected(SelectionEvent e) {
-			}
 		});
 		localRuntimeCombo = new Combo(g, SWT.READ_ONLY);
-		localRuntimeCombo.setLayoutData(UIUtils.createFormData(serverConfigText, 5, null, 0, serverHome, 5, addLocalRuntimeButton, -5));
-		
-		
+		localRuntimeCombo.setLayoutData(LayoutUtils.createFormData(serverConfigText, 5, null, 0, serverHome, 10,
+				addLocalRuntimeButton, -5));
+		this.localRuntimeDeco = UIUtils.createErrorDecoration(SELECT_RUNTIME_ERROR, localRuntimeCombo);
+
 		deployOnlyRadio = new Button(g, SWT.RADIO);
 		deployOnlyRadio.setText("Use a deploy-only server adapter");
-		deployOnlyRadio.setLayoutData(UIUtils.createFormData(localRuntimeCombo,5,null,0,0,5,null,0));
-		
+		deployOnlyRadio.setLayoutData(LayoutUtils.createFormData(localRuntimeCombo, 5, null, 0, 0, 5, null, 0));
+
 		deployFolder = new Label(g, SWT.NONE);
 		deployFolder.setText("Deploy Folder: ");
-		deployFolder.setLayoutData(UIUtils.createFormData(deployOnlyRadio, 7, null, 0, 0, INDENTATION, null, 0 ));
+		deployFolder.setLayoutData(LayoutUtils.createFormData(deployOnlyRadio, 7, null, 0, 0, INDENTATION, null, 0));
 		deployFolderText = new Text(g, SWT.BORDER);
 		deployFolderText.setText("/path/to/deploy");
-		deployFolderText.setLayoutData(UIUtils.createFormData(deployOnlyRadio, 5, null, 0, deployFolder, 5, 100, -5));
-		
+		deployFolderText.setLayoutData(LayoutUtils.createFormData(deployOnlyRadio, 5, null, 0, deployFolder, 10, 100, -5));
+		this.deployFolderDeco = UIUtils.createErrorDecoration(DEPLOY_FOLDER_NOT_EMPTY, deployFolderText);
+		UIUtils.createPreferencesProposalAdapter(deployFolderText, SERVER_DEPLOY_PROPOSAL_KEY);
+
+		Label dummyLabel = new Label(g, SWT.NONE);
+		dummyLabel.setLayoutData(LayoutUtils.createFormData(deployOnlyRadio, 5, null, 0, deployFolderText, 10, 100, -5));
 		
 		IEclipsePreferences prefs = new InstanceScope().getNode(DeltaCloudIntegrationPlugin.PLUGIN_ID);
 		boolean initRSE, initServer;
@@ -171,7 +204,7 @@
 		initServer = prefs.getBoolean(CREATE_SERVER_PREF_KEY, DETAULT_CREATE_SERVERADAPTER);
 		createRSE.setSelection(initRSE);
 		createServer.setSelection(initServer);
-		if( initialHost != null ) {
+		if (initialHost != null) {
 			createRSE.setEnabled(false);
 			createRSE.setSelection(true);
 			createServer.setSelection(true);
@@ -201,7 +234,7 @@
 		deployOnlyRadio.addSelectionListener(listener);
 		remoteDetailsLoc.addModifyListener(modListener);
 		serverHomeText.addModifyListener(modListener);
-		serverConfigText.addModifyListener(modListener); 
+		serverConfigText.addModifyListener(modListener);
 		deployFolderText.addModifyListener(modListener);
 		autoLocalRuntimeCombo.addModifyListener(modListener);
 		localRuntimeCombo.addModifyListener(modListener);
@@ -211,25 +244,36 @@
 	private void fillRuntimeTypeCombo() {
 		localRuntimes.clear();
 		IRuntime[] rts = ServerCore.getRuntimes();
-		ArrayList<String> names = new ArrayList<String>();
-		for( int i = 0; i < rts.length; i++ ) {
-			if( rts[i].getRuntimeType() == null )
+		List<String> names = new ArrayList<String>();
+		for (int i = 0; i < rts.length; i++) {
+			if (rts[i].getRuntimeType() == null)
 				continue;
-			if( rts[i].getRuntimeType().getId().startsWith("org.jboss.") 
+			if (rts[i].getRuntimeType().getId().startsWith("org.jboss.")
 					&& !rts[i].getRuntimeType().getId().equals(IJBossToolingConstants.DEPLOY_ONLY_RUNTIME)) {
 				localRuntimes.add(rts[i]);
 				names.add(rts[i].getName());
 			}
 		}
 		localRuntimeCombo.setItems((String[]) names.toArray(new String[names.size()]));
+		localRuntimeCombo.select(getSelectionIndex(selectedManualRuntimePref.get(), names));
 		autoLocalRuntimeCombo.setItems((String[]) names.toArray(new String[names.size()]));
+		autoLocalRuntimeCombo.select(getSelectionIndex(selectedAutoRuntimePref.get(), names));
+	}
+	
+	private int getSelectionIndex(String item, List<String> items) {
+		int selectionIndex = 0;
+		int listIndex = items.indexOf(item);
+		if (listIndex >= 0) {
+			selectionIndex = listIndex;
+		}
+		return selectionIndex;
 	}
 	
 	protected void configureRuntimesPressed() {
 		ServerUIUtil.showNewRuntimeWizard(addLocalRuntimeButton.getShell(), null, null);
 		fillRuntimeTypeCombo();
 	}
-	
+
 	private void handleSelection(Widget w) {
 		if (w == createRSE) {
 			if (!createRSE.getSelection()) {
@@ -240,33 +284,72 @@
 				createServer.setEnabled(true);
 			}
 		}
-		if( w == createServer ) {
+		if (w == createServer) {
 			refreshServerWidgets();
 		}
 		verifyPageComplete();
 	}
 
 	private void verifyPageComplete() {
-		boolean complete = true;
-		if( createServer.getSelection()) {
-			if( deployOnlyRadio.getSelection()) {
-				complete = !deployFolderText.getText().equals("");
-			} else if( autoScanCheck.getSelection()) {
-				int index = autoLocalRuntimeCombo.getSelectionIndex();
-				complete = index != -1 && !remoteDetailsLoc.getText().equals("");
-			} else if( hardCodeServerDetails.getSelection()) {
-				int index = localRuntimeCombo.getSelectionIndex();
-				complete = index != -1 && !serverHomeText.getText().equals("") && !serverConfigText.getText().equals("");
+		String error = null;
+		deployFolderDeco.hide();
+		autoLocalRuntimeDeco.hide();
+		remoteDetailsLocDeco.hide();
+		localRuntimeDeco.hide();
+		serverHomeDeco.hide();
+		serverConfigDeco.hide();
+		
+		if (createServer.getSelection()) {
+			if (deployOnlyRadio.getSelection()) {
+				if (deployFolderText.getText().equals("")) {
+					error = DEPLOY_FOLDER_NOT_EMPTY;
+					deployFolderDeco.show();
+				}
+			} else if (autoScanCheck.getSelection()) {
+				if (remoteDetailsLoc.getText().equals("")) {
+					remoteDetailsLocDeco.show();
+					error = REMOTE_DETAILS_LOC_ERROR;
+				}
+				if (autoLocalRuntimeCombo.getSelectionIndex() < 0) {
+					autoLocalRuntimeDeco.show();
+					error = SELECT_RUNTIME_ERROR;
+				}
+			} else if (hardCodeServerDetails.getSelection()) {
+				if (serverHomeText.getText().equals("")) {
+					serverHomeDeco.show();
+					error = SERVER_HOME_ERROR;
+				}
+				if (serverConfigText.getText().equals("")) {
+					serverConfigDeco.show();
+					error = SERVER_CONFIG_ERROR;
+				}
+				if (localRuntimeCombo.getSelectionIndex() < 0) {
+					localRuntimeDeco.show();
+					error = SELECT_RUNTIME_ERROR;
+				}
 			}
 		}
-		setPageComplete(complete);
+		storeSelection(autoLocalRuntimeCombo.getSelectionIndex(), autoLocalRuntimeCombo.getItems(), selectedAutoRuntimePref);
+		storeSelection(localRuntimeCombo.getSelectionIndex(), localRuntimeCombo.getItems(), selectedManualRuntimePref);
+
+		setErrorMessage(error);
+		setPageComplete(error == null);
 	}
-	
+
+	private void storeSelection(int selectionIndex, String[] items, StringPreferenceValue preferenceValue) {
+		if (selectionIndex < 0 || items == null || items.length == 0) {
+			return;
+		}
+
+		String value = items[selectionIndex];
+		preferenceValue.store(value);
+	}
+
 	private void refreshServerWidgets() {
-		if( initialHost != null ) {
+		if (initialHost != null) {
 			createRSE.setEnabled(false);
 		}
-		
+
 		boolean enabled = createServer.getSelection();
 		serverDetailsGroup.setEnabled(enabled);
 		autoScanCheck.setEnabled(enabled);
@@ -284,8 +367,8 @@
 		localRuntimeLabel.setEnabled(enabled);
 		localRuntimeCombo.setEnabled(enabled);
 	}
-	
-	public ChainedJob getPerformFinishJob(final DeltaCloudInstance instance) {
+
+	public ChainedJob createPerformFinishJob(final DeltaCloudInstance instance) {
 		IEclipsePreferences prefs = new InstanceScope().getNode(DeltaCloudIntegrationPlugin.PLUGIN_ID);
 		prefs.putBoolean(CREATE_RSE_PREF_KEY, createRSE.getSelection());
 		prefs.putBoolean(CREATE_SERVER_PREF_KEY, createServer.getSelection());
@@ -295,32 +378,32 @@
 			// ignore
 		}
 
-		if( !createRSE.getSelection())
+		if (!createRSE.getSelection())
 			return null;
-		
-		CreateRSEFromInstanceJob j = 
-			new CreateRSEFromInstanceJob(instance, INewInstanceWizardPage.NEW_INSTANCE_FAMILY);
+
+		CreateRSEFromInstanceJob j =
+				new CreateRSEFromInstanceJob(instance, INewInstanceWizardPage.NEW_INSTANCE_FAMILY);
 
-		if( createServer.getSelection()) {
+		if (createServer.getSelection()) {
 			String[] data = null;
 			String type = null;
-			if( deployOnlyRadio.getSelection()) {
+			if (deployOnlyRadio.getSelection()) {
 				type = CreateServerFromRSEJob.CREATE_DEPLOY_ONLY_SERVER;
-				data = new String[]{deployFolderText.getText()};
-			} else if( autoScanCheck.getSelection()) {
+				data = new String[] { deployFolderText.getText() };
+			} else if (autoScanCheck.getSelection()) {
 				type = CreateServerFromRSEJob.CHECK_SERVER_FOR_DETAILS;
 				int index = autoLocalRuntimeCombo.getSelectionIndex();
 				String rtId = localRuntimes.get(index).getId();
-				data = new String[]{remoteDetailsLoc.getText(), rtId};
-			} else if( hardCodeServerDetails.getSelection()) {
+				data = new String[] { remoteDetailsLoc.getText(), rtId };
+			} else if (hardCodeServerDetails.getSelection()) {
 				type = CreateServerFromRSEJob.SET_DETAILS_NOW;
 				int index = localRuntimeCombo.getSelectionIndex();
 				String rtId = localRuntimes.get(index).getId();
-				data = new String[]{serverHomeText.getText(), serverConfigText.getText(), rtId};
+				data = new String[] { serverHomeText.getText(), serverConfigText.getText(), rtId };
 			}
-			if( type != null && data != null ) {
+			if (type != null && data != null) {
 				CreateServerFromRSEJob job2 = new CreateServerFromRSEJob(type, data, instance);
-				if( initialHost != null ) {
+				if (initialHost != null) {
 					job2.setHost(initialHost);
 					return job2;
 				}
@@ -329,5 +412,5 @@
 		}
 		return j;
 	}
-	
+
 }
Index: META-INF/MANIFEST.MF
===================================================================
--- META-INF/MANIFEST.MF	(revision 29286)
+++ META-INF/MANIFEST.MF	(working copy)
@@ -30,4 +30,5 @@
  org.jboss.ide.eclipse.as.rse.core;bundle-version="[0.9.0,2.0.0)",
  org.eclipse.wst.server.core;bundle-version="[1.1.204,2.0.0)",
  org.eclipse.wst.server.ui;bundle-version="[1.1.205,2.0.0)",
- org.eclipse.jsch.core;bundle-version="1.1.200"
+ org.eclipse.jsch.core;bundle-version="1.1.200",
+ com.jcraft.jsch;bundle-version="0.1.41"
Index: src/org/jboss/tools/deltacloud/integration/wizard/CreateRSEFromInstanceJob.java
===================================================================
--- src/org/jboss/tools/deltacloud/integration/wizard/CreateRSEFromInstanceJob.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/integration/wizard/CreateRSEFromInstanceJob.java	(working copy)
@@ -10,78 +10,112 @@
  *******************************************************************************/
 package org.jboss.tools.deltacloud.integration.wizard;
 
+import java.text.MessageFormat;
+
+import org.eclipse.core.runtime.CoreException;
 import org.eclipse.core.runtime.IProgressMonitor;
 import org.eclipse.core.runtime.IStatus;
-import org.eclipse.core.runtime.NullProgressMonitor;
+import org.eclipse.core.runtime.OperationCanceledException;
 import org.eclipse.core.runtime.Status;
 import org.eclipse.core.runtime.SubProgressMonitor;
 import org.eclipse.core.runtime.jobs.Job;
 import org.eclipse.core.runtime.preferences.InstanceScope;
 import org.eclipse.osgi.util.NLS;
 import org.eclipse.rse.core.model.IHost;
-import org.eclipse.rse.core.subsystems.IConnectorService;
-import org.eclipse.rse.services.clientserver.messages.SystemMessageException;
+import org.eclipse.rse.services.clientserver.messages.SystemOperationFailedException;
 import org.eclipse.rse.subsystems.files.core.subsystems.IRemoteFileSubSystem;
-import org.eclipse.swt.widgets.Display;
 import org.jboss.tools.deltacloud.core.DeltaCloudInstance;
 import org.jboss.tools.deltacloud.core.job.AbstractInstanceJob;
+import org.jboss.tools.deltacloud.integration.DeltaCloudIntegrationPlugin;
 import org.jboss.tools.deltacloud.integration.Messages;
+import org.jboss.tools.deltacloud.integration.rse.util.DeltaCloudRSEConstants;
 import org.jboss.tools.deltacloud.integration.rse.util.RSEUtils;
 import org.jboss.tools.deltacloud.ui.Activator;
-import org.jboss.tools.deltacloud.ui.ErrorUtils;
 import org.jboss.tools.deltacloud.ui.IDeltaCloudPreferenceConstants;
 import org.osgi.service.prefs.Preferences;
 
+import com.jcraft.jsch.JSchException;
+
 public class CreateRSEFromInstanceJob extends AbstractInstanceJob {
+	/** the timeout for trying to connect to the new instance */
+	private static final long CONNECT_TIMEOUT = 3 * 60 * 1000;
+
 	private Job nextJob2 = null;
+
 	public CreateRSEFromInstanceJob(DeltaCloudInstance instance, String family) {
 		super("Create RSE Host from DeltaCloud Instance", instance, family);
 	}
-	public IStatus doRun(IProgressMonitor monitor) {
+
+	public IStatus doRun(IProgressMonitor monitor) throws CoreException {
 		return runRSEJob(getInstance(), monitor);
 	}
-	
+
 	public void setNextJob(Job job) {
 		super.setNextJob(job);
 		this.nextJob2 = job;
 	}
-	
-	private IStatus runRSEJob(DeltaCloudInstance instance, IProgressMonitor monitor) {
-		String hostname = RSEUtils.createHostName(instance);
-		if (hostname != null && hostname.length() > 0 && isAutoconnect()) {
+
+	private IStatus runRSEJob(DeltaCloudInstance instance, IProgressMonitor monitor) throws CoreException {
+		if (monitor.isCanceled()) {
+			return Status.CANCEL_STATUS;
+		}
+
+		String hostname = RSEUtils.createRSEHostName(instance);
+		if (hostname == null || hostname.length() <= 0) {
+			return Status.CANCEL_STATUS;
+		}
+
+		if (isAutoconnect()) {
 			try {
-				monitor.beginTask("Create RSE Server", 100);
+				monitor.beginTask(MessageFormat.format("Create RSE to server {0}", hostname), 100);
 				String connectionName = RSEUtils.createConnectionName(instance);
-				IHost host = RSEUtils.createHost(connectionName,
-						RSEUtils.createHostName(instance),
+				IHost host = RSEUtils.createHost(
+						DeltaCloudRSEConstants.USERNAME,
+						connectionName,
+						RSEUtils.createRSEHostName(instance),
 						RSEUtils.getSSHOnlySystemType(),
 						RSEUtils.getSystemRegistry());
-				if( nextJob2 != null && nextJob2 instanceof CreateServerFromRSEJob) {
-					((CreateServerFromRSEJob)nextJob2).setHost(host);
+				if (nextJob2 != null && nextJob2 instanceof CreateServerFromRSEJob) {
+					((CreateServerFromRSEJob) nextJob2).setHost(host);
 				}
 				monitor.worked(10);
-				
-				SubProgressMonitor submon = new SubProgressMonitor(monitor, 90);
-				initialConnect(host);
-				return RSEUtils.connect(RSEUtils.getConnectorService(host), 90000, submon);
+				IStatus credentials =
+						triggerCredentialsDialog(host, new SubProgressMonitor(monitor, 10));
+				if (credentials.isOK())
+					return RSEUtils.connect(RSEUtils.getConnectorService(host), CONNECT_TIMEOUT,
+							new SubProgressMonitor(monitor, 80));
+				return credentials;
 			} catch (Exception e) {
-				return ErrorUtils.handleError(Messages.ERROR,
-						NLS.bind(Messages.COULD_NOT_LAUNCH_RSE_EXPLORER2, instance.getName()),
-						e, Display.getDefault().getActiveShell());
+				throw new CoreException(
+						new Status(IStatus.ERROR, DeltaCloudIntegrationPlugin.PLUGIN_ID,
+								NLS.bind(Messages.COULD_NOT_LAUNCH_RSE_EXPLORER2, instance.getName())));
 			}
 		}
 		return Status.OK_STATUS;
 	}
-	
-	private void initialConnect(IHost host) {
+
+	private IStatus triggerCredentialsDialog(IHost host, IProgressMonitor monitor) {
 		try {
+			monitor.setTaskName(MessageFormat.format("Initiating connection to {0}...", host.getName()));
 			IRemoteFileSubSystem system = RSEUtils.findRemoteFileSubSystem(host);
-			system.connect(new NullProgressMonitor(), true);
-		} catch(Exception e) {
-			// ignore, expected, the server probably isn't up yet. 
+			system.connect(monitor, true /* force credentials dialog */);
+		} catch (Exception e) {
+			if (e instanceof OperationCanceledException)
+				return Status.CANCEL_STATUS;
+			if (e instanceof SystemOperationFailedException) {
+				Exception f = ((SystemOperationFailedException) e).getRemoteException();
+				if (f != null && f instanceof JSchException) {
+					// User selected No on accept hostkey
+					if (f.getMessage().contains("reject HostKey:"))
+						return Status.CANCEL_STATUS;
+				}
+			}
+		} finally {
+			monitor.done();
 		}
+		return Status.OK_STATUS;
 	}
-	
+
 	private boolean isAutoconnect() {
 		Preferences prefs = new InstanceScope().getNode(Activator.PLUGIN_ID);
 		boolean autoConnect = prefs.getBoolean(IDeltaCloudPreferenceConstants.AUTO_CONNECT_INSTANCE, true);
